<template>
  <div class="container mx-auto mt-5">
    <div class="w-full black-flexible1-customize">
      <entry-filter
        v-model:search="searchedGame"
        :menus="gameEntryTabMenus"
        @onFilterClicked="onFilter"
        @search-games="updateSearchResult"
      />
      <render
        :loading="isLoading"
        :games="gameCollection"
        :is-has-group-title="true"
        :group-title="gameGroupTitle"
        class-game-name="text-white"
        :active-tab="activeTab"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from "vue";
import EntryFilter from "./components/lobby/entry-filter.client.vue";
import Render from "./components/lobby/render.client.vue";
import { useGameEntryComponent } from "@/composables/useTheme";
import { IGameEntryMenu, TabGameMenu } from "@/models/gameEntryFilter";
import { GameFilterRequest } from "@/models/bsiGameList";

export default defineComponent({
  components: { EntryFilter, Render },
  setup() {
    const {
      isLoading,
      headerTab,
      initialGameEntry,
      searchedGame,
      handleSearchGame,
      getGameEntryFiltered,
      activeTab,
      updateSearchResult,
      gameCollection,
    } = useGameEntryComponent();
    const gameEntryTabMenus = computed(() => {
      const result: IGameEntryMenu[] = [
        {
          Menus: headerTab.value.map((item) => new TabGameMenu(item, "main")),
          IsSearchBox: false,
          Justify: "left",
          Theme: "common",
        },
        {
          Menus: [],
          IsSearchBox: true,
          Justify: "left",
          Theme: "main",
        },
      ];
      return result;
    });

    const gameGroupTitle = ref("Top Games");
    const onFilter = (request: GameFilterRequest) => {
      getGameEntryFiltered(request);
      gameGroupTitle.value =
        request.Value === "" ? request.Type : request.Value;
    };
    watch(searchedGame, () => {
      handleSearchGame();
    });
    return {
      gameEntryTabMenus,
      searchedGame,
      onFilter,
      initialGameEntry,
      gameGroupTitle,
      isLoading,
      updateSearchResult,
      gameCollection,
    };
  },
});
</script>
<style lang="scss">
:root {
  --gf-background-color: var(--border);
  --new-text-color: white;
  --gf-text-active-color: white;
}
.black-flexible1-customize {
  .game-filter-bg {
    background-color: transparent;
  }
  position: relative;
  .grid.grid-cols-10 {
    grid-template-columns: repeat(12, minmax(0, 1fr));
  }
  .game-filter {
    margin-bottom: 15px;
  }
  .grid {
    margin-bottom: 15px;
    .col-span-2 {
      border: none;
      .cursor-pointer div {
        justify-content: center;
        // height: 38px;
      }
      .cursor-pointer img {
        width: 100%;
      }
    }
  }
  .grid .flex .flex {
    .game-tab-menu .flex {
      flex-direction: row;
      margin-bottom: 8px;
      .game-tab-icon,
      .game-tab-icon-active {
        width: 1.25rem;
        height: auto;
      }
    }
    span {
      color: white;
    }
  }
  div .w-full.text-white {
    display: none;
  }
}
</style>
